/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.test.jsf;

import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.inject.Named;
import javax.enterprise.context.RequestScoped;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import javax.transaction.HeuristicMixedException;
import javax.transaction.HeuristicRollbackException;
import javax.transaction.NotSupportedException;
import javax.transaction.RollbackException;
import javax.transaction.SystemException;
import org.test.model.jpa.Clientes;
import org.test.model.jpa.Operaciones;
import org.test.model.jpa.RoutingOrders;

/**
 *
 * @author xavier
 */
@Named(value = "managedRBean")
@RequestScoped
public class ManagedRBean {
    @PersistenceContext(unitName = "WebApplication1PU")
    private EntityManager em;
    @Resource
    private javax.transaction.UserTransaction utx;

    /** Creates a new instance of ManagedRBean */
    public ManagedRBean() {
    }
    
    public void test() {
        try {
            utx.begin();
//            Clientes c = em.find(Clientes.class, 1);
//
//            Operaciones o = new Operaciones();
//            o.setCliente(c);
//            RoutingOrders ro = new RoutingOrders();
//            ro.setOperaciones(o);
//            o.setRoutingOrders(ro);
//            em.persist(ro);
            
//            RoutingOrders ro = em.find(RoutingOrders.class, 1);
//            ro.setFechaRegistro(new Date());
//            System.out.println("ro: " + ro + ", o: " + ro.getOperaciones());
            
            String q = "SELECT t0 FROM RoutingOrders t0 JOIN t0.operaciones t1 JOIN t1.cliente t2";
            TypedQuery<RoutingOrders> query = em.createQuery(q, RoutingOrders.class);
            List<RoutingOrders> resultList = query.getResultList();
            System.out.println("resultList: "  + resultList);
            System.out.println(resultList.get(0).getOperaciones().getCliente());
            
            utx.commit();
        } catch (RollbackException ex) {
            Logger.getLogger(ManagedRBean.class.getName()).log(Level.SEVERE, null, ex);
        } catch (HeuristicMixedException ex) {
            Logger.getLogger(ManagedRBean.class.getName()).log(Level.SEVERE, null, ex);
        } catch (HeuristicRollbackException ex) {
            Logger.getLogger(ManagedRBean.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SecurityException ex) {
            Logger.getLogger(ManagedRBean.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalStateException ex) {
            Logger.getLogger(ManagedRBean.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NotSupportedException ex) {
            Logger.getLogger(ManagedRBean.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SystemException ex) {
            Logger.getLogger(ManagedRBean.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        
    }
    
}
